"""empty message

Revision ID: 21f341a50bc8
Revises: 0759b66ff396
Create Date: 2021-11-17 21:48:20.617361

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql
from eviction_tracker.detainer_warrants.models import Case
from sqlalchemy.orm.session import Session

# revision identifiers, used by Alembic.
revision = '21f341a50bc8'
down_revision = '0759b66ff396'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.rename_table('detainer_warrants', 'cases')
    op.execute('ALTER INDEX detainer_warrants_pkey RENAME TO cases_pkey')
    op.add_column('cases', sa.Column(
        'type', sa.String(length=50), nullable=True))
    op.execute("UPDATE cases SET type = 'detainer_warrant'")

    op.drop_constraint('canvass_warrants_detainer_warrant_docket_id_fkey',
                       'canvass_warrants', type_='foreignkey')
    op.create_foreign_key(None, 'canvass_warrants', 'cases', [
                          'detainer_warrant_docket_id'], ['docket_id'], ondelete='CASCADE')
    op.drop_constraint('detainer_warrant_defendants_detainer_warrant_docket_id_fkey',
                       'detainer_warrant_defendants', type_='foreignkey')
    op.create_foreign_key(None, 'detainer_warrant_defendants', 'cases', [
                          'detainer_warrant_docket_id'], ['docket_id'], ondelete='CASCADE')
    op.drop_constraint('judgements_detainer_warrant_id_fkey',
                       'judgements', type_='foreignkey')
    op.create_foreign_key(None, 'judgements', 'cases', [
                          'detainer_warrant_id'], ['docket_id'])
    op.drop_constraint('pleading_documents_docket_id_fkey',
                       'pleading_documents', type_='foreignkey')
    op.create_foreign_key(None, 'pleading_documents', 'cases', [
                          'docket_id'], ['docket_id'])

    session = Session(bind=op.get_bind())

    for case in session.query(Case):
        if 'GT' in case.docket_id:
            case.type = 'detainer_warrant'
        elif 'GC' in case.docket_id:
            case.type = 'civil_warrant'
        else:
            case.type = 'uncategorized_case'
        session.add(case)

    session.commit()
    ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.rename_table('cases', 'detainer_warrants')
    op.execute('ALTER INDEX cases_pkey RENAME TO detainer_warrants_pkey')
    op.drop_column('detainer_warrants', 'type')
    op.drop_constraint('pleading_documents_docket_id_fkey',
                       'pleading_documents', type_='foreignkey')
    op.create_foreign_key('pleading_documents_docket_id_fkey',
                          'pleading_documents', 'detainer_warrants', ['docket_id'], ['docket_id'])
    op.drop_constraint('judgements_detainer_warrant_id_fkey',
                       'judgements', type_='foreignkey')
    op.create_foreign_key('judgements_detainer_warrant_id_fkey', 'judgements',
                          'detainer_warrants', ['detainer_warrant_id'], ['docket_id'])
    op.drop_constraint('detainer_warrant_defendants_detainer_warrant_docket_id_fkey',
                       'detainer_warrant_defendants', type_='foreignkey')
    op.create_foreign_key('detainer_warrant_defendants_detainer_warrant_docket_id_fkey', 'detainer_warrant_defendants',
                          'detainer_warrants', ['detainer_warrant_docket_id'], ['docket_id'], ondelete='CASCADE')
    op.drop_constraint('canvass_warrants_detainer_warrant_docket_id_fkey',
                       'canvass_warrants', type_='foreignkey')
    op.create_foreign_key('canvass_warrants_detainer_warrant_docket_id_fkey', 'canvass_warrants',
                          'detainer_warrants', ['detainer_warrant_docket_id'], ['docket_id'], ondelete='CASCADE')
    ### end Alembic commands ###
